<?php
/*
Plugin Name: E-Mail Notification
Version: 1.5
Plugin URI: http://www.briangroce.com/software/wp-email-notification.html
Description: Allow People To Sign Up For E-Mail Notifications
Author: Brian Groce
Author URI: http://briangroce.com/
*/

    //********************************************************//
    //                    CREATE VARIABLES
    //********************************************************//
    if(!isset($wpdb->posts)) {
       $wpdb->posts               = $table_prefix . 'posts';
       $wpdb->postmeta            = $table_prefix . 'postmeta';
       $wpdb->users               = $table_prefix . 'users';
      }

    if(!isset($wpdb->email_list)) {
       $wpdb->email_list          = $table_prefix . 'email_list';
      }

    // add_action(hook, action, priority)
    // [priority 0-10 with 0 being the highest priority]
    add_action('publish_post', 'send_notification', 5);

function send_notification($post_ID)  {

    //********************************************************//
    //                   CONFIG SECTION
    //********************************************************//

      $from_email = 'you@yoursite.com';
      $nice_urls = 'no';     // yes or no
      $show_content = 'no';  // yes or no - send the entire post in email
      $html_email = 'no';    // yes for HTML, no for Text

    //********************************************************//
    //                     OTHER SETTINGS
    //********************************************************//

      # Site Information
      $site_name = get_settings('blogname');
      $site_url = get_settings('siteurl');
      $blog_url = get_settings('home');

      # Set Global
      global $wpdb;

    //********************************************************//
    //                   GRAB POST STATUS
    //********************************************************//
		$prev_status = $_POST['prev_status'];
		$post_status = $_POST['post_status'];

		if (isset($_POST['publish'])) $post_status = 'publish';

		//********************************************************//
		// are we going from draft/private to published?
		//********************************************************//
		if ($prev_status != 'publish' && $post_status == 'publish') {

	    //********************************************************//
	    //               SELECT TITLE FROM DB
	    //********************************************************//
	    $query = "SELECT post_title, post_content FROM $wpdb->posts WHERE ID = '$post_ID'";
      $row = $wpdb->get_row($query);

	    $post_title = stripslashes($row->post_title);
      $post_title = str_replace(array("“","?","’","–","—","…"), array('"','"','','','','...'), $post_title);
      $post_title = utf8_decode($post_title);

	    $post_content = stripslashes($row->post_content);
      $post_content = str_replace(array("“","?","’","–","—","…","&nbsp;"), array('"','"','','','','...',' '), $post_content);
      $post_content = utf8_decode($post_content);

      if ($html_email != 'yes'){
        $post_content = str_replace(array("<ul>","</ul>","<ol>","</ol>","<li>","</li>"), array('','','','','* ',''), $post_content);
        $post_content = strip_tags($post_content);
        }

	    //********************************************************//
	    //                      BUILD URL
	    //********************************************************//

			if ($post_title != '' && $nice_urls == 'yes'){
	    	// This is for the nicer URL permalink
		    $url = get_permalink($post_ID);
				}

	    else {
	      // This is for the default URL permalink
	      $url = "$blog_url/index.php?p=$post_ID";
	      }

	    //********************************************************//
	    //             SELECT USERS TO EMAIL FROM DB
	    //********************************************************//

	    $query = "SELECT email_addr FROM $wpdb->email_list WHERE gets_mail = 1";

	    $res = mysql_query($query);

	    while ($row = mysql_fetch_assoc($res)) {
	        $addr = $row['email_addr'];

        //********************************************************//
        //                 HTML VERSION OF MESSAGE
        //********************************************************//

				if ($html_email == 'yes'){

  				if ($post_title != ''){
  					$msg =  "A new entry titled '$post_title' has been posted to $site_name.<br><br>";
  					}

  				else {
  					$msg =  "A new entry has been posted to $site_name.<br><br>";
  					}

          if ($show_content == 'yes') {
            $msg .= "$post_content<br><br>";
            }

    	      $msg .= "<a href=\"$url\">$url</a><br><br>";
    	      $msg .= "<hr>";
  					$msg .= "You have signed up to receive these notifications. <br><br>";
  					$msg .= "If you would like to unsubscribe, visit the url below:<br>";

  	        if ($nice_urls == 'yes'){
  	          // This is for the nicer URL permalink
  	          $msg .= "<a href=\"$site_url/maillist/unsub/$addr\">$site_url/maillist/unsub/$addr</a><br>";
  	          }

  	        else {
  	          // This is for the default URL permalink
  	          $msg .= "<a href=\"$site_url/maillist/index.php?action=unsub&addr=$addr\">$site_url/maillist/index.php?action=unsub&addr=$addr</a><br>";
  	          }
            }

        //********************************************************//
        //                 TEXT VERSION OF MESSAGE
        //********************************************************//

        else {
  				if ($post_title != ''){
  					$msg =  "A new entry titled '$post_title' has been posted to $site_name.\n\n";
  					}

  				else {
  					$msg =  "A new entry has been posted to $site_name.\n\n";
  					}

          if ($show_content == 'yes') {
            $msg .= "$post_content\n\n";
            }

    	      $msg .= "$url\n\n";
    	      $msg .= "------------------------------------------------------\n\n";
  					$msg .= "You have signed up to receive these notifications. \n\n";
  					$msg .= "If you would like to unsubscribe, visit the url below:\n";

  	        if ($nice_urls == 'yes'){
  	          // This is for the nicer URL permalink
  	          $msg .= "$site_url/maillist/unsub/$addr\n";
  	          }

  	        else {
  	          // This is for the default URL permalink
  	          $msg .= "$site_url/maillist/index.php?action=unsub&addr=$addr\n";
  	          }
  	        }

        //********************************************************//
        //                     EMAIL HEADER
        //********************************************************//
            $header  = "MIME-Version: 1.0\r\n";

            if ($html_email == 'yes'){
             $header .= "Content-Type: text/html; charset=\"" . get_settings('blog_charset') . "\"\r\n";
              }

            else {
              $header .= "Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"\r\n";
              }

  					$header .= "From: $site_name <$from_email>\n";
            $header .= "Reply-To: $from_email\n";
            $header .= "Return-Path: $from_email\n";

        //********************************************************//
        //                        SUBJECT
        //********************************************************//
  					if ($post_title != ''){
              $subject = "$site_name: $post_title";
              }

  					else {
  					  $subject = "$site_name: New Untitled Entry";
  						}

        //********************************************************//
        //                        MAIL IT
        //********************************************************//

						Mail($addr, $subject, $msg, $header);
	    }

		} // end if moving from draft/private to published

    return $post_ID;  // It may be buggy otherwise.

}

?>